Loading...
Searching...
No Matches
Dune::IterativeSolver< X, Y > Class Template Referenceabstract
Iterative Solvers Template Library (ISTL) » Iterative Solvers

Base class for all implementations of iterative solvers. More...

`#include <dune/istl/solver.hh>`

Inheritance diagram for Dune::IterativeSolver< X, Y >:

## Classes

class | Iteration
| Class for controlling iterative methods. More...

## Public Types

typedef X | domain_type
| Type of the domain of the operator to be inverted.
typedef Y | range_type
| Type of the range of the operator to be inverted.
typedef X::field_type | field_type
| The field type of the operator.
typedef FieldTraits< field_type >::real_type | real_type
| The real type of the field type (is the same if using real numbers, but differs for std::complex).
typedef Simd::Scalar< real_type > | scalar_real_type
| scalar type underlying the field_type

## Public Member Functions

| IterativeSolver (const LinearOperator< X, Y > &op, Preconditioner< X, Y > &prec, scalar_real_type reduction, int maxit, int verbose)
| General constructor to initialize an iterative solver.
| IterativeSolver (const LinearOperator< X, Y > &op, const ScalarProduct< X > &sp, Preconditioner< X, Y > &prec, scalar_real_type reduction, int maxit, int verbose)
| General constructor to initialize an iterative solver.
| IterativeSolver (std::shared_ptr< const LinearOperator< X, Y > > op, std::shared_ptr< Preconditioner< X, X > > prec, const ParameterTree &configuration)
| Constructor.
| IterativeSolver (std::shared_ptr< const LinearOperator< X, Y > > op, std::shared_ptr< const ScalarProduct< X > > sp, std::shared_ptr< Preconditioner< X, X > > prec, const ParameterTree &configuration)
| Constructor.
| IterativeSolver (std::shared_ptr< const LinearOperator< X, Y > > op, std::shared_ptr< const ScalarProduct< X > > sp, std::shared_ptr< Preconditioner< X, Y > > prec, scalar_real_type reduction, int maxit, int verbose)
| General constructor to initialize an iterative solver.
void | apply (X &x, X &b, double reduction, InverseOperatorResult &res) override
| Apply inverse operator with given reduction factor.
SolverCategory::Category | category () const override
| Category of the solver (see SolverCategory::Category).
std::string | name () const
virtual void | apply (X &x, Y &b, InverseOperatorResult &res)=0
| Apply inverse operator,.
virtual void | apply (X &x, Y &b, double reduction, InverseOperatorResult &res)=0
| apply inverse operator, with given convergence criteria.

## Protected Types

enum | { iterationSpacing = 5 , normSpacing = 16 }

## Protected Member Functions

void | printHeader (std::ostream &s) const
| helper function for printing header of solver output
template<typename CountType, typename DataType>
void | printOutput (std::ostream &s, const CountType &iter, const DataType &norm, const DataType &norm_old) const
| helper function for printing solver output
template<typename CountType, typename DataType>
void | printOutput (std::ostream &s, const CountType &iter, const DataType &norm) const
| helper function for printing solver output

## Protected Attributes

std::shared_ptr< const LinearOperator< X, Y > > | _op
std::shared_ptr< Preconditioner< X, Y > > | _prec
std::shared_ptr< const ScalarProduct< X > > | _sp
scalar_real_type | _reduction
int | _maxit
int | _verbose
SolverCategory::Category | _category

## Detailed Description

template<class X, class Y>
class Dune::IterativeSolver< X, Y >

Base class for all implementations of iterative solvers.

This class provides all storage, which is needed by the usual iterative solvers. In additional it provides all the necessary constructors, which are then only imported in the actual solver implementation.

## Member Typedef Documentation

## domain_type

template<class X, class Y>

typedef X Dune::InverseOperator< X, Y >::domain_type

inherited

Type of the domain of the operator to be inverted.

## field_type

template<class X, class Y>

typedef X::field_type Dune::InverseOperator< X, Y >::field_type

inherited

The field type of the operator.

## range_type

template<class X, class Y>

typedef Y Dune::InverseOperator< X, Y >::range_type

inherited

Type of the range of the operator to be inverted.

## real_type

template<class X, class Y>

typedef FieldTraits<field_type>::real_type Dune::InverseOperator< X, Y >::real_type

inherited

The real type of the field type (is the same if using real numbers, but differs for std::complex).

## scalar_real_type

template<class X, class Y>

typedef Simd::Scalar<real_type> Dune::InverseOperator< X, Y >::scalar_real_type

inherited

scalar type underlying the field_type

## Member Enumeration Documentation

## anonymous enum

template<class X, class Y>

anonymous enum

protected inherited

Enumerator
iterationSpacing |
normSpacing |

## Constructor & Destructor Documentation

## IterativeSolver() [1/5]

template<class X, class Y>

Dune::IterativeSolver< X, Y >::IterativeSolver | ( | const LinearOperator< X, Y > & | op,
|  | Preconditioner< X, Y > & | prec,
|  | scalar_real_type | reduction,
|  | int | maxit,
|  | int | verbose )

inline

General constructor to initialize an iterative solver.

Parameters

  op | The operator we solve.
  prec | The preconditioner to apply in each iteration of the loop. Has to inherit from Preconditioner.
  reduction | The relative defect reduction to achieve when applying the operator.
  maxit | The maximum number of iteration steps allowed when applying the operator.
  verbose | The verbosity level.

Verbose levels are:

- 0 : print nothing
- 1 : print initial and final defect and statistics
- 2 : print line for each iteration

## IterativeSolver() [2/5]

template<class X, class Y>

Dune::IterativeSolver< X, Y >::IterativeSolver | ( | const LinearOperator< X, Y > & | op,
|  | const ScalarProduct< X > & | sp,
|  | Preconditioner< X, Y > & | prec,
|  | scalar_real_type | reduction,
|  | int | maxit,
|  | int | verbose )

inline

General constructor to initialize an iterative solver.

Parameters

  op | The operator we solve.
  sp | The scalar product to use, e. g. SeqScalarproduct.
  prec | The preconditioner to apply in each iteration of the loop. Has to inherit from Preconditioner.
  reduction | The relative defect reduction to achieve when applying the operator.
  maxit | The maximum number of iteration steps allowed when applying the operator.
  verbose | The verbosity level.

Verbose levels are:

- 0 : print nothing
- 1 : print initial and final defect and statistics
- 2 : print line for each iteration

## IterativeSolver() [3/5]

template<class X, class Y>

Dune::IterativeSolver< X, Y >::IterativeSolver | ( | std::shared_ptr< const LinearOperator< X, Y > > | op,
|  | std::shared_ptr< Preconditioner< X, X > > | prec,
|  | const ParameterTree & | configuration )

inline

Constructor.

Parameters

  op | The operator we solve
  prec | The preconditioner to apply in each iteration of the loop.
  configuration | ParameterTree containing iterative solver parameters.

ParameterTree Key | Meaning
--- | ---
reduction | The relative defect reduction to achieve when applying the operator
maxit | The maximum number of iteration steps allowed when applying the operator
verbose | The verbosity level

See ISTL_Factory for the ParameterTree layout and examples.

## IterativeSolver() [4/5]

template<class X, class Y>

Dune::IterativeSolver< X, Y >::IterativeSolver | ( | std::shared_ptr< const LinearOperator< X, Y > > | op,
|  | std::shared_ptr< const ScalarProduct< X > > | sp,
|  | std::shared_ptr< Preconditioner< X, X > > | prec,
|  | const ParameterTree & | configuration )

inline

Constructor.

Parameters

  op | The operator we solve
  sp | The scalar product to use, e. g. SeqScalarproduct.
  prec | The preconditioner to apply in each iteration of the loop.
  configuration | ParameterTree containing iterative solver parameters.

ParameterTree Key | Meaning
--- | ---
reduction | The relative defect reduction to achieve when applying the operator
maxit | The maximum number of iteration steps allowed when applying the operator
verbose | The verbosity level

See ISTL_Factory for the ParameterTree layout and examples.

## IterativeSolver() [5/5]

template<class X, class Y>

Dune::IterativeSolver< X, Y >::IterativeSolver | ( | std::shared_ptr< const LinearOperator< X, Y > > | op,
|  | std::shared_ptr< const ScalarProduct< X > > | sp,
|  | std::shared_ptr< Preconditioner< X, Y > > | prec,
|  | scalar_real_type | reduction,
|  | int | maxit,
|  | int | verbose )

inline

General constructor to initialize an iterative solver.

Parameters

  op | The operator we solve.
  sp | The scalar product to use, e. g. SeqScalarproduct.
  prec | The preconditioner to apply in each iteration of the loop. Has to inherit from Preconditioner.
  reduction | The relative defect reduction to achieve when applying the operator.
  maxit | The maximum number of iteration steps allowed when applying the operator.
  verbose | The verbosity level.

Verbose levels are:

- 0 : print nothing
- 1 : print initial and final defect and statistics
- 2 : print line for each iteration

## Member Function Documentation

## apply() [1/3]

template<class X, class Y>

virtual void Dune::InverseOperator< X, Y >::apply | ( | X & | x,
|  | Y & | b,
|  | double | reduction,
|  | InverseOperatorResult & | res )

pure virtual inherited

apply inverse operator, with given convergence criteria.

Warning
  Right hand side b may be overwritten!

Parameters

  x | The left hand side to store the result in.
  b | The right hand side
  reduction | The minimum defect reduction to achieve.
  res | Object to store the statistics about applying the operator.

Exceptions

  SolverAbort | When the solver detects a problem and cannot continue

Implemented in Dune::Cholmod< Vector, Index >, and Dune::IterativeSolver< X, X >.

## apply() [2/3]

template<class X, class Y>

virtual void Dune::InverseOperator< X, Y >::apply | ( | X & | x,
|  | Y & | b,
|  | InverseOperatorResult & | res )

pure virtual inherited

Apply inverse operator,.

Warning
  Note: right hand side b may be overwritten!

Parameters

  x | The left hand side to store the result in.
  b | The right hand side
  res | Object to store the statistics about applying the operator.

Exceptions

  SolverAbort | When the solver detects a problem and cannot continue

Implemented in Dune::BiCGSTABSolver< X >, Dune::CGSolver< X >, Dune::Cholmod< Vector, Index >, Dune::CompleteFCGSolver< X >, Dune::GeneralizedPCGSolver< X >, Dune::GradientSolver< X >, Dune::LoopSolver< X >, Dune::MINRESSolver< X >, Dune::RestartedFCGSolver< X >, and Dune::RestartedGMResSolver< X, X >.

## apply() [3/3]

template<class X, class Y>

void Dune::IterativeSolver< X, Y >::apply | ( | X & | x,
|  | X & | b,
|  | double | reduction,
|  | InverseOperatorResult & | res )

inline override

Apply inverse operator with given reduction factor.

apply inverse operator, with given convergence criteria.

Warning
  Right hand side b may be overwritten!

Parameters

  x | The left hand side to store the result in.
  b | The right hand side
  reduction | The minimum defect reduction to achieve.
  res | Object to store the statistics about applying the operator.

Exceptions

  SolverAbort | When the solver detects a problem and cannot continue

## category()

template<class X, class Y>

SolverCategory::Category Dune::IterativeSolver< X, Y >::category | ( |  | ) | const

inline override virtual

Category of the solver (see SolverCategory::Category).

Implements Dune::InverseOperator< X, Y >.

## name()

template<class X, class Y>

std::string Dune::IterativeSolver< X, Y >::name | ( |  | ) | const

inline

## printHeader()

template<class X, class Y>

void Dune::InverseOperator< X, Y >::printHeader | ( | std::ostream & | s | ) | const

inline protected inherited

helper function for printing header of solver output

## printOutput() [1/2]

template<class X, class Y>
template<typename CountType, typename DataType>

void Dune::InverseOperator< X, Y >::printOutput | ( | std::ostream & | s,
|  | const CountType & | iter,
|  | const DataType & | norm ) const

inline protected inherited

helper function for printing solver output

## printOutput() [2/2]

template<class X, class Y>
template<typename CountType, typename DataType>

void Dune::InverseOperator< X, Y >::printOutput | ( | std::ostream & | s,
|  | const CountType & | iter,
|  | const DataType & | norm,
|  | const DataType & | norm_old ) const

inline protected inherited

helper function for printing solver output

## Member Data Documentation

## _category

template<class X, class Y>

SolverCategory::Category Dune::IterativeSolver< X, Y >::_category

protected

## _maxit

template<class X, class Y>

int Dune::IterativeSolver< X, Y >::_maxit

protected

## _op

template<class X, class Y>

std::shared_ptr<const LinearOperator<X,Y> > Dune::IterativeSolver< X, Y >::_op

protected

## _prec

template<class X, class Y>

std::shared_ptr<Preconditioner<X,Y> > Dune::IterativeSolver< X, Y >::_prec

protected

## _reduction

template<class X, class Y>

scalar_real_type Dune::IterativeSolver< X, Y >::_reduction

protected

## _sp

template<class X, class Y>

std::shared_ptr<const ScalarProduct<X> > Dune::IterativeSolver< X, Y >::_sp

protected

## _verbose

template<class X, class Y>

int Dune::IterativeSolver< X, Y >::_verbose

protected

The documentation for this class was generated from the following file:

- solver.hh